unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ppCtrls, ppVar, ppPrnabl, ppClass, ppBands, ppCache,
  daDataView, daQueryDataView, daDBBDE, ppModule, daDataModule, ppComm,
  ppRelatv, ppProd, ppReport,
  Contnrs;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppTitleBand1: TppTitleBand;
    ppLabel1: TppLabel;
    ppSystemVariable1: TppSystemVariable;
    ppSystemVariable2: TppSystemVariable;
    ppDBText1: TppDBText;
    ppLabel2: TppLabel;
    ppDBText2: TppDBText;
    ppLabel3: TppLabel;
    ppLine1: TppLine;
    ppLine2: TppLine;
    Button1: TButton;
    procedure ppReport1PrintDialogClose(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ppReport1PrintingComplete(Sender: TObject);
  private
    FDevices: TObjectList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ppDevice, ppFilDev;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  ppReport1.Print;
end;

procedure TForm1.ppReport1PrintDialogClose(Sender: TObject);
var
  lTextFileDevice: TppTextFileDevice;
begin
  if (ppReport1.PrintDialog.ModalResult <> mrOK) then Exit;

  // create a list object to manage the devices
  FDevices := TObjectList.Create;

  // create the file devices
  lTextFileDevice := TppTextFileDevice.Create(nil);
  lTextFileDevice.FileName := 'c:\TestReport.txt';

  // attach the device to the report's publisher
  lTextFileDevice.Publisher := ppReport1.Publisher;

  // add the device to the list
  FDevices.Add(lTextFileDevice);

end;


procedure TForm1.ppReport1PrintingComplete(Sender: TObject);
begin
  // free the devies
  FDevices.Free;
  FDevices := nil;

end;

end.
